/*This program is like boggle mixed with solitaire.
Authors: Lori Carter, Ben Johnson and Dane Bustrum
Date: 3/15/04 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class Bogataire extends JFrame
{	
	//declare required variables and structures
	private String title;
	private String [][] char_grid =new String[4][4]; 
	private JTextField TF_score;
	private JButton JB_score;
	private JButton JB_record;
	private JButton JB_reset;
   private JButton JB_calculate;
	private JButton JB_start_over;
   private JTextArea TA_words;
	private JButton[][] letters = new JButton[4][4];
	private JLabel JL_curword = new JLabel("Current Word");
	private JLabel JL_score = new JLabel("Score");
	private JTextField TF_current_word;
	private Container pane = getContentPane();
	private B_Handler b_handler;	
   private String cur_word = " ";
	private String word_list = "";
	private int counter=0,oldrow=0,oldcol=0;
	private String[] dictionary;
	private BufferedReader inFile;
	private StringTokenizer tokenizer;
	//New GUI Constructor
		public Bogataire()
		{
			
			//get random nums for letters
			for (int row=0; row<4; row++)
			for (int col=0;col<4; col++)
			{
				double seed = Math.random();
				System.out.println("rand num is " + seed);
				int int_seed =(int) Math.round(seed*1000); //need 97-122
				if (int_seed>900) int_seed=int_seed/10;

				// check to see if this is unique
				boolean unique=true;
				String tempStr = (""+((char)int_seed));
				for (int k=0;k<=row-1;k++)
					for(int j=0;j<4;j++)
					{
						if (tempStr==char_grid[k][j])
                     unique=false;
					}

				for(int j=0;j<=col;j++)
					{
						if (tempStr==char_grid[row][j])
                     unique=false;
					}

				while (((int_seed<97) || (int_seed>122))||!unique)
				{
					seed = Math.random();
					int_seed =(int)Math.round(seed*1000);
 
					// check to see if we have this already
					if ((int_seed>=97)&&(int_seed<=122))
					{
						unique=true;
						tempStr = (""+((char)int_seed));
						// search for the letters that have already been placed looking for duplicates
						for (int k=0;k<=row-1;k++)
							for(int j=0;j<4;j++)
							{
								if (tempStr.equals(char_grid[k][j]))
								{					
     		  	              unique=false;
								}
							}

						for(int j=0;j<=col;j++)
							{
								if (tempStr.equals(char_grid[row][j]))
								{		
       		              unique=false;
								}
							}
					}
				} 
				// we have a unique letter, place it			
				char_grid[row][col]=(""+((char)int_seed));				
			}

		//create the GUI
		setTitle("Welcome to Bogataire");
		setSize(510,380);
		b_handler = new B_Handler(); 

		// no layout, we will place things with coordinates
		pane.setLayout(null);

		// size and place the components - order doesn't matter
		JL_curword.setSize(240,20);
		JL_curword.setLocation(10,260);
		pane.add(JL_curword);
		TF_current_word = new JTextField(30);
		TF_current_word.setSize(240,30);
		TF_current_word.setLocation(10,280);
		TF_current_word.setText(cur_word);
		pane.add(TF_current_word);
		TF_score = new JTextField(25);
		TF_score.setSize(200,30);
		TF_score.setLocation(260,240);
		pane.add(TF_score);
		TA_words=new JTextArea();
		TA_words.setText(word_list);
		TA_words.setSize(200,200);
		TA_words.setLocation(260,10);
		pane.add(TA_words);
		JL_score.setSize(240,20);
		JL_score.setLocation(260,220);
		pane.add(JL_score);
		JB_record=new JButton("record");
		JB_record.setSize(75,30);
		JB_record.setLocation(260,280);
		JB_record.addActionListener(b_handler);  // register the handler for the button
		pane.add(JB_record);
		JB_calculate=new JButton("calculate");
		JB_calculate.setSize(90,30);
		JB_calculate.setLocation(335,280);
		JB_calculate.addActionListener(b_handler);
		pane.add(JB_calculate);
		JB_start_over=new JButton("start over");
		JB_start_over.setSize(100,30);
		JB_start_over.setLocation(330,310);
		JB_start_over.addActionListener(b_handler);
		pane.add(JB_start_over);
		JB_reset=new JButton("reset");
		JB_reset.setSize(65,30);
		JB_reset.setLocation(425,280);
		JB_reset.addActionListener(b_handler);
		pane.add(JB_reset);

		// put the boggle buttons in the correct relative places
		int x,y;
		x=10;
		y=10;
		for (int row=0; row<4; row++)
		{
			for (int col=0; col<4; col++)
			{	letters[row][col]=new JButton(char_grid[row][col]);
				letters[row][col].addActionListener(b_handler);
				letters[row][col].setSize(60,60);
				letters[row][col].setLocation(x,y);
				pane.add(letters[row][col]);
				x=x+60;
			}
			y=y+60;
			x=10;
		}
	
		// Display the GUI
		setVisible(true);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
	}
	//Task 2 - start over word button
	private void start_over()
	{
		cur_word = " ";
		TF_current_word.setText(cur_word);
	}
	//New reset board method
	private void reset_board()
	{
	for (int row=0; row<4; row++)
			for (int col=0;col<4; col++)
			{
				double seed = Math.random();
				int int_seed =(int) Math.round(seed*1000); //need 97-122
				if (int_seed>900) int_seed=int_seed/10;

				// check to see if this is unique
				boolean unique=true;
				String tempStr = (""+((char)int_seed));

				// 1st check the complete rows that have been filled in
				for (int k=0;k<=row-1;k++)
					for(int j=0;j<4;j++)
					{
						if (tempStr==char_grid[k][j])
                     unique=false;
					}

				// now check the last row fragment
				for(int j=0;j<=col;j++)
					{
						if (tempStr==char_grid[row][j])
                     unique=false;
					}

				// keep looking if not in right range or not unique
				while (((int_seed<97) || (int_seed>122))||!unique)
				{
					seed = Math.random();
					int_seed =(int)Math.round(seed*1000); 
					// check to see if we have this already
					if ((int_seed>=97)&&(int_seed<=122))
					{
						unique=true;
						tempStr = (""+((char)int_seed));
						for (int k=0;k<=row-1;k++)
							for(int j=0;j<4;j++)
							{
								if (tempStr.equals(char_grid[k][j]))
								{					
     		  	              unique=false;
								}
							}

						for(int j=0;j<=col;j++)
							{
								if (tempStr.equals(char_grid[row][j]))
								{		
       		              unique=false;
								}
							}
					}
				} 
				// we've got a unique, correct character. Keep it.		
				char_grid[row][col]=(""+((char)int_seed));
				
		}
		// put characters on the buttons
		for (int row=0; row<4; row++)
			for (int col=0; col<4; col++)
				letters[row][col].setText(char_grid[row][col]);
		
		word_list = "";
		TA_words.setText(word_list);
		TF_score.setText(" ");
		}

	// this method adds a letter to the current word
	private void place_letter(String letter, int r, int c)
	{
		
		if((counter>0)&&(((r==oldrow)||(r==oldrow+1)||(r==oldrow-1))&&((c==oldcol)||(c==oldcol+1)||(c==oldcol-1))))
		{
			cur_word = cur_word + letter;
			TF_current_word.setText(cur_word);
			oldrow=r;
			oldcol=c;
			counter++;
		}
		else
			TF_current_word.setText("Invalid Word");
		if(counter==0)
		{
			cur_word = cur_word + letter;
			TF_current_word.setText(cur_word);
			oldrow=r;
			oldcol=c;
			counter++;
		}
	}

	// this method places a word in the word list text area
	private void record_word()
	{
		try
		{
			inFile = new BufferedReader (new FileReader("dictionary.txt"));
			//compile dictionary into array
			tokenizer=new StringTokenizer(inFile.readLine());
			dictionary=new String[1049];
			for(int i=0;i<1049;i++)
				dictionary[i] = tokenizer.nextToken();
			for(int j=0;j<1049;j++)
				if(dictionary[j].equals(cur_word.substring(1)))
				{
					word_list = word_list+cur_word + '\n';
					TA_words.setText(word_list);
					cur_word=" ";
					TF_current_word.setText(cur_word);
				}
				else
					TF_current_word.setText("Word not found");
		}
		catch(IOException ioeRef)
		{
			System.out.println(ioeRef.toString());
		}
		
	}


	// this method calculates the score - a word is worth
	// its length squared
	private void calc_score()
	{
		int total=0;
		int word_size=0;
		for (int i=0; i<word_list.length();i++)
		{
			// each word ends with a newline 
			if ((word_list.charAt(i)!=('\n'))&&((i+1)!=(word_list.length())))
				word_size++;
			else
				{
					total = total + (word_size-1)*(word_size-1);
					word_size=0;
				}
		}
		// make the total into a String for a parameter to the setText routine
		TF_score.setText(" "+total);
	}

	// This handler works for all the actions. The parameter e
   // tells the method which button was pushed
	private class B_Handler implements ActionListener
	{
		public void actionPerformed (ActionEvent e)
		{
			boolean found=false;  // for efficiency

			// was one of the letter buttons pushed?
				for (int row=0; row<4; row++)
				{
					for (int col=0; col<4; col++)
					{
						if (e.getActionCommand().equals(char_grid[row][col])&&found!=true)
						{
								place_letter(char_grid[row][col], row, col);
								found=true;
						}
					}
				}
			// if it wasn't a letter, was it reset, calculate or record?
			if (!found)
				{
					if (e.getActionCommand().equals("reset"))
					{
						reset_board();
						counter=0;
						TF_current_word.setText("Word not found");
					}
					else if (e.getActionCommand().equals("record"))
					{
						record_word();
						counter=0;
					}
					else if (e.getActionCommand().equals("calculate"))
					{
						calc_score();
						counter=0;
					}
					else if(e.getActionCommand().equals("start over"))
					{	
						start_over();
						counter=0;
					}
				}
		}
	}

	// Make the GUI we define above
	public static void main (String[] args)throws IOException
	{	
		Bogataire play = new Bogataire();
	}
}